/* 
 * The main code library for live_agents.
 * Requires jQuery.
 * 
 * $Id: live_call.js,v 1.2 2015/04/27 13:15:40 lenz Exp $
 */


function setupPage(data) {

    fillSpan("cmp_number", data.call.number);
    fillSpan("cmp_retry", data.call.nRetry);
    fillSpan("cmp_state", data.call.state);
    fillSpan("cmp_campaign", data.call.campaignRun);
    fillSpan("call_list", data.callRecord.listId.name);

    fillList("call_input_attr", fillAttrs(data, true));
    fillList("call_output_attr", fillAttrs(data, false));

}

/**
 * Tutti gli attributi di tipo dato.
 * 
 * @param {type} data
 * @param {type} isInput
 * @returns {fillAttrs.out|Array}
 */

function fillAttrs(data, isInput) {

    var out = [];
    data.callRecord.attributes.forEach( function( attr ) {            
        if (attr.isInput === isInput) {
            out.push(attr);
        }
    });

    return out;
}

/**
 * Imposta uno span con un HTML di default se vuoto.
 * 
 * @param {type} id
 * @param {type} html
 * @param {type} htmlEmpty
 * @returns {undefined}
 */

function fillSpan(id, html, htmlEmpty) {

    if (html.length === 0) {
        html = htmlEmpty;
    }

    $("#" + id).html(html);

}

function fillList(id, data) {

    var html = "<i>None.</i>";

    if (data.length > 0) {
        
        data.sort(function(a, b){
            return a.attrName > b.attrName;
        });
        
        html = "<ol><table>";
        data.forEach( function(attr ) {
            html += "<tr>"
               + "<td>"
               + "<i>" + attr.attrName + "</i> "
               + "</td> <td>&nbsp;</td> <td>"
               + attr.attrValue
               + "</td>"
               + "</tr>";
        });
        html += "</table></ol><p>";
    }

    fillSpan(id, html, "");

}


/**
 * Esegue la query a server.
 * 
 * @param {type} agentCode
 * @param {type} widCode  WombatId  WBT.1234
 * @param {type} uidCode  uniqueId  12345.67
 * @param {type} tokenid L'ID del token
 * @returns {undefined}
 */

function runRequest(agentCode, widCode, uidCode, tokenid) {

    $("#ok").hide();
    $("#ko").hide();

    $.ajax({
        method: "POST",
        url: "../api/callinfo/",
        data: {agent: agentCode, wid: widCode, unqid: uidCode, auth_token_id: tokenid }
    })
            .done(function (msg) {

                console.log("M;sg received", msg)

                if (msg.callFound) {
                    $("#ok").show();
                    setupPage(msg);
                } else {
                    $("#ko").show();
                }

            });

    // setupPage(res)

}

