function SchemaUpdater() {

    this.context = {};
    this.methods = [];
    this.ok = 0;
    this.skip = 0;
    this.err = 0;
    this.updateFor = "U";
    this.autorun = 1;

    this.onFinish = function() {
        alert( "Please define an onFinish!")
    }

    this.buildId = function( s ) {
        return s.replace(new RegExp("\\.", 'g'), "_");
    }

    this.runNext = function() {
        if ( this.methods.length > 0 ) {
            var method = this.methods.shift();

            $( "#tabaction").html( "Now running: " + method[1] + " <img src='icon_loader.gif'>" );
            var caller = this;

            this.context["method"] = method[0];
            this.context["mode"] = "U";
            this.context["updateFor"] = this.updateFor;


            $.ajax({
                type: 'POST',
                url: "SchemaUpdater_ajax.jsp",
                data: this.context
            })
            .success( function(data, textStatus, jqXHR) {caller.onSuccess( data );} )
            .error( function(jqXHR, textStatus, errorThrown) {alert("Error: " + textStatus + " - " + errorThrown);} )
        } else {
            $( "#tabaction").html( " " );
            this.onFinish();
        }
    }

    this.onSuccess = function( data ) {

        $( "#tabaction").html( "..." );

        var method   = data["method"];
        var state    = data["state"];
        var testDesc = data["test_name"];
        var testResp = data["test_resp"];
        var testDur  = data["test_dur"];

        var message = "<tr><td><span class='actstate_" + state + "'>" + testDesc + "</span></td><td>" + testResp + "</td><td style='text-align: right;'>" + testDur + " ms</td></tr>";

        $('#tabresults tr:first').after(message);

        this.debug( "Got state: " + state  + " for " + method );

        if ( state == "OK" ) {
            this.setBarClass( method, "ok" );
            this.ok += 1;
            this.runNext();

        } else
        if ( state == "SKIPPED" ) {
            this.setBarClass( method, "skip");
            this.skip += 1;
            this.runNext();

        } else
        if ( state == "ERROR" ) {
            this.setBarClass( method, "err");
            this.err += 1;
            this.onFinish();
            
        } else
        {
            this.debug( "Unknown reult: " + state );
        }
    }

    this.setBarClass = function( id_, s ) {
        var id = this.buildId( id_ );
        this.debug( "Set " + id + " to " + s);

        if ( $('#' + id).length == 0) {
            this.debug( "Not found " + id );

        } else {
            $( "#" + id ).removeClass("empty");
            $( "#" + id ).addClass(s);
        }
    }


    this.debug = function( s) {
        $( "#debug").html( s + "<br>" + $("#debug").html())
    }

    this.init = function() {

        $('#tabresults tr:not(:first)' ).remove();

        // carica la lista degli updater
        var caller = this;
        $.ajax({
            type: 'POST',
            url: "SchemaUpdater_ajax.jsp",
            data: {
                "mode": "L",
                "updateFor": this.updateFor
            }
        })
        .success( function(data, textStatus, jqXHR) {
            caller.methods = data;
            caller.initAfterModuleList();
        } )
        .error( function(jqXHR, textStatus, errorThrown) {alert("Error: " + textStatus + " - " + errorThrown);} )

    }

    this.initAfterModuleList = function() {
        // prepara la tabella di avanzamento
        var table = "<tr>";
        var i = 0;
        
        for ( i = 0; i < this.methods.length; i++ ) {
            table += "<td id='"+ this.buildId( this.methods[i][0] ) + "'>&nbsp;</td>";
        }
        table += "</tr>";

        $( "#tabloader" ).html( table );

        for ( i = 0; i < this.methods.length; i++ ) {
            this.setBarClass( this.methods[i][0], "empty" );
        }

        if ( this.autorun > 0 ) {
            this.runNext();
        }
    }



    this.setContext = function( k, v ) {
        this.context[k] = v;
    }

}




